/* $Id: clc_stralloc.c,v 1.8 2003/05/13 12:24:11 hfuru Exp $ */
/*
 * Copyright(c) 2003, Hallvard B. Furuseth <h.b.furuseth@usit.uio.no>
 * COPYING RESTRICTIONS APPLY, see COPYING file.
 */

#include <errno.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "clc_string.h"
#include "clc_errno.h"

char *
clc_stralloc(const char *arg1, ...)
{
	size_t len;
	const char *arg;
	char *ret, *end;
	va_list ap;
	int bad;

	/* compute length of result string */
	len = 1;
	bad = 0;
	va_start(ap, arg1);
	for (arg = arg1; arg != (char *)0; arg = va_arg(ap, char *)) {
		size_t arglen = strlen(arg);
		len += arglen;
		if(len < arglen) {
			/* string length too large for size_t */
			bad = 1;
			break;
		}
	}
	va_end(ap);
	if(bad) {
		errno = ERANGE;
		return NULL;
	}

	/* create result string */
	ret = malloc(len);
	if(ret == NULL) {
		errno = CLC_ENOMEM;
	} else {
		end = ret;
		*end = '\0';
		va_start(ap, arg1);
		for (arg = arg1; arg != (char *)0; arg = va_arg(ap, char *))
			 end = clc_stpcpy(end, arg);
		va_end(ap);
	}

	return ret;
}
