/* $Id: clc_strrev.c,v 1.9 2003/05/12 16:20:29 hfuru Exp $ */
/*
 * Copyright(c) 2003, B. Augestad <boa@metasystems.no>
 * COPYING RESTRICTIONS APPLY, see COPYING file.
 */

#include <string.h>
#include "clc_assert.h"
#include "clc_string.h"

char *
clc_strrev(char *s)
{
	clc_assert_not_null(clc_strrev, s);
	return clc_memrev(s, strlen(s));
}

void *
clc_memrev(void *s, size_t n)
{
	clc_assert_not_null(clc_memrev, s);

	if(n) {
		unsigned char *beg = s;
		unsigned char *end = (unsigned char *)s + n - 1;
		while(beg < end) {
			unsigned char tmp = *end;
			*end-- = *beg;
			*beg++ = tmp;
		}
	}

	return s;
}
